///////////////////////////////////////
///////////////////////////////////////
////                               ////
////        VMM 1.2 example        ////
////                               ////
////     For more vmm examples     ////
////     visit www.testbench.in    ////
////                               ////
///////////////////////////////////////
///////////////////////////////////////


//-----------------------------------------------------------------------------
//  This is a dummy rtl
//-----------------------------------------------------------------------------

module dummy_rtl(address, i_data, rdwr, clock, en, reset, o_data);
  input [7:0] address;
  input [7:0] i_data;
  output reg [7:0] o_data;
  input rdwr;
  input clock;
  input en;
  input reset;

  reg [7:0] mem [255:0];

  always@(posedge clock or posedge reset) begin
    if(reset) begin
      o_data <= 8'h0;
    end else if (en) begin
      if (rdwr) begin
        mem[address] <= i_data;  
      end else begin
        o_data <= mem[address];  
      end
    end else begin
      o_data <= 8'h0;
    end
  end

endmodule   

//-----------------------------------------------------------------------------
// end of file 
//-----------------------------------------------------------------------------

